/**
** This software is distributed under the terms of the General Public License.  
** 
** Program : BuildIT!
** Version : 0.2
** Authors : Artur Prusakiewicz <prusak@mat.uni.torun.pl>
**	     Michal Switala <scisly@mat.uni.torun.pl>
** E-MAIL  : build@mat.uni.torun.pl
** WWW     : http://www.mat.uni.torun.pl/~scisly/buildit/
**           http://www.mat.uni.torun.pl/~prusak/buildit/
**/
#define _APPLET

#include "../main/Frame.h"
#include <qwidget.h>
#include <qframe.h>
#include <qlist.h>
#include <qstring.h>

#include <stdio.h>

#ifndef _PROPS
Q_DECLARE(QListM,QString);
#endif

class MyClass: public QWidget
{
  Q_OBJECT
public:
  MyClass(QWidget *parent=0, const char *name=0);
  void watchIt(QWidget *widget);
  QWidget *traced(){return touchedWidget;}
  void setTraced(QWidget *widget){me=FALSE;touchedWidget=widget;}
  void setId(QString val){id=val;};
  QString getId(){return id;}
  void setFileName(QString val);
  QString getFileName(){return fileName;}
  QString getCpt(){return cpt;}
  void setHomeDir(QString val){homeDir=val;}
  void setType(int val){type=val;}
  int getType(){return type;}
  void setTitle(QString t){title=t;}
  QString getTitle(){return title;}
  void setMenu(QWidget *widget,bool val);
  bool getMenu(){return ismenu;}
  void raiseIT(){raise();}
  QWidget *mmb;
  int which; // which project it is
  int counter;
  QListM(QString) evt;
public slots:
  void setWidgetTouched(QWidget *widget);
  void semOp();
  void semDown();
signals:
  void touch(QWidget *widget);
  void mv(int x,int y);
  void press(QWidget *widget,QMouseEvent *event);
  void release(QWidget *widget,QMouseEvent *event);
  void itsMe(MyClass *widget);
  void dbclick(QWidget *widget,QMouseEvent *event);
  void leave();
  void noEnter();
private:
  bool ismenu;
  int type;
  QString id,fileName,cpt,title,homeDir;
  QWidget *touchedWidget;
  Frame *active;
  bool me;
  bool sem;

  void mouseMoveEvent(QMouseEvent *event){emit mv(event->x(),event->y());}
  void mousePressEvent(QMouseEvent *event){emit touch(this);emit press(this,event);}
  void mouseReleaseEvent(QMouseEvent *event){emit touch(this);emit release(this,event);}
  void mouseDoubleClickEvent(QMouseEvent *event){emit touch(this);emit dbclick(this,event);} 
  void resizeEvent(QResizeEvent *event);
  void leaveEvent(QEvent *event){emit leave();}
  void closeEvent(QCloseEvent *event){event->ignore();}
}; 



